// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnTest1.C   Version 1.4
//   LastSCCS    : 1/23/92  12:33:02
//   LastEdit    : "Mon Jan 20 11:31:04 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#include <Gina/GnBasic.h>

class GnLeft : public virtual GnObject {
    META_DEF_1_V(GnLeft,GnObject);
  public:
    GnLeft() {}
  protected:
    int i;
};

class GnRight : public virtual GnObject {
    META_DEF_1_V(GnRight,GnObject);
  public:
    GnRight() {}
  protected:
    int j;
};

META_IMPL_1_V(GnRight,GnObject,)

META_IMPL_1_V(GnLeft,GnObject,)

class GnMultiple : public GnLeft, virtual public GnRight {
    META_DEF_2_NV(GnMultiple,GnLeft,GnRight);
  public:
    GnMultiple() {}
  protected:
    int k;
};

META_IMPL_2_NV(GnMultiple,GnLeft,GnRight,);

class GnMultipleSub : public GnMultiple {
    META_DEF_1(GnMultipleSub,GnMultiple);
  public:
    GnMultipleSub() {}
  protected:
    int l;
};

META_IMPL_1(GnMultipleSub,GnMultiple,);

int main(unsigned int, char *[])
{
    GnClass::Initialize();
    
    GnPathname *pn = new GnPathname;
    GnObjectList *olist = new GnObjectList;
    GnObjectListIterator *oit = new GnObjectListIterator(olist);

    GnString *str = new GnString("Andreas Baecker");
    GnInteger *gint = new GnInteger(12345678);
    GnFloat *gfloat = new GnFloat(3.1415279);
    GnIntegerItem *intitem = new GnIntegerItem("Andreas Baecker", 29);
    GnFloatItem *fitem = new GnFloatItem("Andreas Baecker", 29.5);

    GnMultipleSub *msub = new GnMultipleSub();
    
    // Call a virtual function for each class
    pn->DumpOn(cout); cout << endl;
    olist->DumpOn(cout); cout << endl;
    oit->DumpOn(cout); cout << endl;
    gint->DumpOn(cout); cout << endl;
    gfloat->DumpOn(cout); cout << endl;
    intitem->GnInteger::DumpOn(cout); cout << endl;
    fitem->GnFloat::DumpOn(cout); cout << endl;

    // Print a list of classes known to the class manager

    GnClassListIterator *class_it = GnClass::ClassListIterator();

    cerr << endl << "List of classes in the system:\n";
    for( class_it->Start(); ! class_it->Off(); class_it->Forth() ) {
	cerr << "    "       << class_it->Item()->Name() << ":";
	cerr << class_it->Item()->Size() << " Bytes, ";
	//cerr << " Active: "  << class_it->item()->ActiveInstances();
	//cerr << " Deleted: " << class_it->item()->DeletedInstances();
	cerr << endl << "            Base class(es): ";
	GnClassInfoListIterator *bases
	    = class_it->Item()->BaseClassesIterator();
	for(bases->Start(); ! bases->Off(); bases->Forth() ) {
	    cerr << bases->Item()->TheClass()->Name();
	    if( bases->Item()->IsVirtual() )
		cerr << "(virtual)";
	    cerr << ", ";
	}
	delete bases;
	cerr << endl << "            Subclass(es)  : ";
	GnClassInfoListIterator *subs = class_it->Item()->SubclassesIterator();
	for(subs->Start(); ! subs->Off(); subs->Forth() ) {
	    cerr << subs->Item()->TheClass()->Name();
	    if( subs->Item()->IsVirtual() )
		cerr << "(virtual)";
	    cerr << ", ";
	}
	delete subs;
        cerr << endl << endl;
    }
    delete class_it;

    GnClassListIterator *cli1 = GnClass::ClassListIterator();
    GnClassListIterator *cli2 = GnClass::ClassListIterator();

    for(cli1->Start(); ! cli1->Off(); cli1->Forth() ) {
	cerr << cli1->Item()->Name();
	if( cli1->Item()->MI() )
	    cerr << " <==MI== ";
	else
	    cerr << " <====== ";
	for(cli2->Start(); ! cli2->Off(); cli2->Forth() ) {
	    if( cli1->Item()->IsSubclass(cli2->Item()) )
		cerr << cli2->Item()->Name() << ", ";
	}
	cerr << endl;
    }
    
    // Check the meta class protocol

    GnInteger::TypeSafeDownCast((GnObject *)gint)->DumpOn(cerr); cerr << endl;
    GnFloat::TypeSafeDownCast((GnObject *)gfloat)->DumpOn(cerr); cerr << endl;
    GnObject::TypeSafeDownCast((GnObject *)gfloat)->DumpOn(cerr); cerr << endl;
    GnFloat::TypeSafeDownCast((GnObject *)(GnFloat *)fitem)->DumpOn(cerr); cerr << endl;
    GnObject::TypeSafeDownCast(msub)->DumpOn(cerr); cerr << endl;
    GnLeft::TypeSafeDownCast(msub)->DumpOn(cerr); cerr << endl;
    GnRight::TypeSafeDownCast(msub)->DumpOn(cerr); cerr << endl;
    GnMultiple::TypeSafeDownCast(msub)->DumpOn(cerr); cerr << endl;
    GnMultipleSub::TypeSafeDownCast(msub)->DumpOn(cerr); cerr << endl;

    cerr << "GnObject::TypeSafeDownCast(msub) = " <<
            (void *)GnObject::TypeSafeDownCast(msub) << endl;

    cerr << "GnLeft::TypeSafeDownCast(msub) = " <<
            (void *)GnLeft::TypeSafeDownCast(msub) << endl;

    cerr << "GnRight::TypeSafeDownCast(msub) = " <<
            (void *)GnRight::TypeSafeDownCast(msub) << endl;

    cerr << "GnMultiple::TypeSafeDownCast(msub) = " <<
            (void *)GnMultiple::TypeSafeDownCast(msub) << endl;

    cerr << "GnMultipleSub::TypeSafeDownCast(msub) = " <<
            (void *)GnMultipleSub::TypeSafeDownCast(msub) << endl;

    cerr << "Traversing GnMultipleSub: ";
    //msub->TraverseObject();
    cerr << endl << endl;
    cerr << "Traversing GnMultipleSub: ";
    //msub->TraverseObject();
    cerr << endl << endl;

    if( ! GnFloatItem::TypeSafeDownCast((GnObject *)(GnInteger *)intitem) ) {
	// This is what should happen !!!
        cerr << "Failed to cast a GnIntegerItem * into a GnFloatItem * !!!!\n";
    } else {
	cerr << "Unexpected success of downcast !!!!\n" ;
    }
}
