(autoload  'c++-mode      "c++-mode" "C++ programming mode"      t)
(setq auto-mode-alist (cons '("\\.h$"  . c++-mode)
			    (cons '("\\.C$"  . c++-mode)    auto-mode-alist)))

;;
;; customize c++-mode

;; Update "LastEdit:" field in header

(defun c++-update-header ()
  "Insert current time in the standard header at the top."
  (if (not (buffer-modified-p))
      (save-excursion
        (beginning-of-buffer)
	(set-mark (point))
	(setq lineno 0)
	(while (< lineno 24)
	  (if (looking-at "//[ \t]*LastEdit[ \t]*:")
	      (progn
		(search-forward "\"")
		(set-mark (point))
		(search-forward "\"")
		(backward-char 1)
		(delete-region (mark) (point))
		(insert (current-time-string))
		(setq lineno 25)
		(not-modified))
              (progn
		(end-of-line)
		(if (not (eobp))
		    (progn
		      (forward-line 1)
		      (beginning-of-line)
		      (setq lineno (1+ lineno)))
		    (setq lineno 25))))))))

;; insert c++ header template into empty source file

(defun c++-mode-insert-template ()
  (if (= (buffer-size) 0)
      (progn
	(if (string-match ".*\.h$" (buffer-file-name))
	    (insert "#ifndef "
		    (capitalize
		      (substring (buffer-name) 0
				 (string-match "\.h$" (buffer-name))))
		    "_h\n#define "
		    (capitalize
		      (substring (buffer-name) 0
				 (string-match "\.h$" (buffer-name))))
		    "_h\n\n#endif")
	  )
	(if (string-match ".*\.cc$" (buffer-file-name))
	    (insert "static char "
		    (capitalize
		      (substring (buffer-name) 0
				 (string-match "\.cc$" (buffer-name))))
		    "_Id[] = \"@(#)c++-hook.el	1.1\t2/19/92\";\n\n"))

	(goto-char (point-min))
	(replace-string "." "_")
	(goto-char (point-min))
	(c++-insert-header)
	(not-modified)
	)))

;; setup c++-mode

(defun c++-mode-setup ()
  (progn
    (c++-mode-insert-template)
    (c++-update-header)
    (setq c-tab-always-indent nil)))

(setq c++-mode-hook 'c++-mode-setup)

