// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnLayout.h   Version 1.1
//   LastSCCS    : 2/25/92  12:53:00
//   LastEdit    : "Mon Feb 17 09:27:41 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gnlayout_h
#define Gnlayout_h

enum Direction {eVertical, eHorizontal, eLeft_to_Right, eRight_to_Left};

class GnLayout : public GnObject{
    META_DEF_1(GnLayout,GnObject);
  public:
    GnLayout();
    void SetNodeList(GnSelectionItemList *nodes){ m_nodes = nodes; }
    void SetEdgeList(GnViewEdgeList *edges){ m_edges = edges; }
    void SetDirection(Direction d){ m_direction = d; }
    void SetHorizontalDistance(Dimension d){ m_horizontal_distance = d; }
    void SetVerticalDistance(Dimension d){ m_vertical_distance = d; }
    virtual void DoNodeLayout();
    virtual void DoEdgeLayout();
  protected:
    Dimension m_node_width, m_node_height;
    Dimension m_vertical_distance, m_horizontal_distance;
    Direction m_direction;
    GnSelectionItemList *m_nodes;
    GnViewEdgeList *m_edges;
};

#endif
