// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnLinkedList.h   Version 1.23
//   LastSCCS    : 2/10/92  14:49:28
//   LastEdit    : "Mon Jan 20 10:36:54 1992"
//   Description : 
//   Author      : Andreas Baecker
//   Copyright   : GMD Schloss Birlinghoven

#ifndef _GnLinkedList_h_
#define _GnLinkedList_h_

class GnBiLinkable {
    friend class GnDoubleLinkedList;
    friend class GnDoubleLinkedListIterator;
  private:
    GnBiLinkable() {}
  private:
    GnBiLinkable *next;
    GnBiLinkable *previous;
    void         *item;
};

// Two way linked lists

class GnDoubleLinkedList : public GnObject {
    META_DEF_1(GnDoubleLinkedList,GnObject);
    friend class GnDoubleLinkedListIterator;
  public:
    GnDoubleLinkedList();
    virtual ~GnDoubleLinkedList();
  public:
    int Length() const
	{ return length; }
    int Empty() const
	{ return length == 0; }
  public:
    void Clear();
  protected:
    int _Member(void *item) const;
    void *_First() const;
    void *_Last() const;
  protected:
    void _Append(void *);
    void _Prepend(void *);
    void *_RemoveFirst();
    void *_RemoveLast();
    void *_Remove(void *);
    void _RemoveAllOccurences(void *);
  private:
    void InitEmpty();
  private:
    GnBiLinkable head;
    int          length;
    int          active_iterators;
};

        //META_DEF_1(SUB_LIST_CLASS,GnDoubleLinkedList); \

#define DefGenericList(SUB_LIST_CLASS, LIST_ITEM_CLASS) \
    class SUB_LIST_CLASS : public GnDoubleLinkedList { \
      public: \
        SUB_LIST_CLASS() {}; \
	int Member(LIST_ITEM_CLASS *item) const \
	    { return GnDoubleLinkedList::_Member((void *)item); } \
        LIST_ITEM_CLASS *First() const \
          { return (LIST_ITEM_CLASS *)GnDoubleLinkedList::_First(); }; \
        LIST_ITEM_CLASS *Last() const \
          { return (LIST_ITEM_CLASS *)GnDoubleLinkedList::_Last(); }; \
        LIST_ITEM_CLASS *RemoveFirst() \
          { return (LIST_ITEM_CLASS *)GnDoubleLinkedList::_RemoveFirst(); } \
        LIST_ITEM_CLASS *RemoveLast() \
          { return (LIST_ITEM_CLASS *)GnDoubleLinkedList::_RemoveLast(); } \
	void Append(LIST_ITEM_CLASS *item) \
          { GnDoubleLinkedList::_Append((void *)item); } \
	void Prepend(LIST_ITEM_CLASS *item) \
	    { GnDoubleLinkedList::_Prepend((void *)item); } \
        void Remove(LIST_ITEM_CLASS *item) \
            { GnDoubleLinkedList::_Remove((void *)item); } \
        void RemoveAllOccurences(LIST_ITEM_CLASS *item) \
            { GnDoubleLinkedList::_RemoveAllOccurences((void *)item); } \
    }

#define ImplGenericList(SUB_LIST_CLASS)

    //META_IMPL_1(SUB_LIST_CLASS,GnDoubleLinkedList);

#endif








