// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnMotif.h   Version 1.8
//   LastSCCS    : 1/14/92  15:16:05
//   LastEdit    : "Mon Jan 13 10:53:29 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gnmotif_h
#define Gnmotif_h

// All the Motif and X11 stuff
// GnBasic.h must be included before including this file !!

// Out goal is to avoid deep nested include files and multiply including
// the same file wherever possible. This is realized by:
//  - Every .C file obtain the requird class definitions only by 
//    including GnBasic.h, GnMotif.h and GnFramework.h
//  - The .h file which contain class definitions never include another file
//  - All class definitions are included in GnBasic.h, GnMotif.h and
//    GnFramework.h
//  - If a class A inherits from class B, then B.h must be included in
//    GnBasic.h/GnMotif.h/GnFramework.h before A.h
//  - GnMotif.h requires GnBasic.h, GnFramework.h requires GnMotif.h

// Include all the X11 and Motif stuff
// Resolve type conflicts for types Object and String by #defines


#define XTFUNCPROTO
#define Object      XObject
#define String      XString
#define Boolean     XBoolean
#  include <X11/Intrinsic.h>
#define Boolean     XBoolean
#define String      XString
#  include <X11/StringDefs.h>
#  include <Xm/Xm.h>
#  include <Xm/AtomMgr.h>
#  include <Xm/FileSB.h>
#  include <Xm/Text.h>
#  include <X11/Xatom.h>
#undef String
#undef Object

// Global table for maintaining widgets

#include <Gina/GnWidgetTable.h>

// Abstract classes

#include <Gina/GnCallback.h>
#include <Gina/GnWidget.h>
#include <Gina/GnPrimitive.h>
#include <Gina/GnComposite.h>
#include <Gina/GnConstraint.h>
#include <Gina/GnManager.h>

// Shell classes

#include <Gina/GnShell.h>
#include <Gina/GnDialogShell.h>
#include <Gina/GnTopLevelShell.h>
#include <Gina/GnApplicationShell.h>
#include <Gina/GnMenuShell.h>

#include <Gina/GnToolkit.h>

// Abstract classes used for multiple inheritance in dialog classes

#include <Gina/GnDialogMixin.h>

// Primitives & Labels & Buttons

#include <Gina/GnLabel.h>
#include <Gina/GnLabelG.h>
#include <Gina/GnArrowButton.h>
#include <Gina/GnArrowButtonG.h>
#include <Gina/GnCascadeButton.h>
#include <Gina/GnCascadeButtonG.h>
#include <Gina/GnToggleButton.h>
#include <Gina/GnToggleButtonG.h>
#include <Gina/GnPushButton.h>
#include <Gina/GnPushButtonG.h>
#include <Gina/GnDrawnButton.h>
#include <Gina/GnScrollBar.h>
#include <Gina/GnSeparator.h>
#include <Gina/GnSeparatorG.h>
#include <Gina/GnText.h>
#include <Gina/GnList.h>

// Abstract classes used for multiple inheritance in selection classes

#include <Gina/GnSelectionItem.h>
#include <Gina/GnSelection.h>

#include <Gina/GnFrame.h>

// XmRowColumn based widgets

#include <Gina/GnRowColumn.h>
#include <Gina/GnMenuBar.h>
#include <Gina/GnOptionMenu.h>
#include <Gina/GnRadioBox.h>
#include <Gina/GnPulldownMenuPane.h>
#include <Gina/GnPopupMenuPane.h>
#include <Gina/GnOptionGroup.h>
#include <Gina/GnSelectionFrame.h>
#include <Gina/GnRadioGroup.h>
#include <Gina/GnToggleGroup.h>

// Composite widgets

#include <Gina/GnDrawingArea.h>
#include <Gina/GnBulletinBoard.h>
#include <Gina/GnSelectionBox.h>
#include <Gina/GnCommandWidget.h>
#include <Gina/GnMessageBox.h>
#include <Gina/GnForm.h>
#include <Gina/GnPanedWindow.h>
#include <Gina/GnScale.h>
#include <Gina/GnSelectionList.h>
#include <Gina/GnFileSelectBox.h>
#include <Gina/GnScrolledW.h>
#include <Gina/GnScrolledList.h>
#include <Gina/GnScrolledText.h>
#include <Gina/GnMainWindow.h>

// timer class 

#include <Gina/GnTimer.h>

// Dialog classes

#include <Gina/GnBulletinBD.h>
#include <Gina/GnFileSelectD.h>
#include <Gina/GnFormD.h>

#include <Gina/GnMessageD.h>
#include <Gina/GnAlternativeD.h>
#include <Gina/GnErrorD.h>
#include <Gina/GnInformationD.h>
#include <Gina/GnQuestionD.h>
#include <Gina/GnWarningD.h>
#include <Gina/GnWorkingD.h>

// Our own widget classes

#include <Gina/GnLabeledText.h>

#endif
