/* @(#)GnScrolledW.h	1.11 2/4/91 */

#ifndef Gina_ScrolledW_H
#define Gina_ScrolledW_H


class GnScrolledWindow : public GnManager {
    META_DEF_1(GnScrolledWindow,GnManager);
  public:

    GnScrolledWindow();

    /* Resources */
    DEF_SET_GET(clipWindow, GnWidget *);
    DEF_SET_GET(horizontalScrollBar, GnScrollBar *);
    DEF_SET_GET_I(scrollBarDisplayPolicy, unsigned char);
    DEF_SET_GET_I(scrollBarPlacement, unsigned char);
    DEF_SET_GET_I(scrolledWindowMarginHeight, Dimension);
    DEF_SET_GET_I(scrolledWindowMarginWidth, Dimension);
    DEF_SET_GET_I(scrollingPolicy, unsigned char);
    DEF_SET_GET_I(spacing, Dimension);
    DEF_SET_GET(verticalScrollBar, GnScrollBar *);
    DEF_SET_GET_I(visualPolicy, unsigned char);

  protected:
    virtual Widget create_widget(GnWidget *, char *);
    virtual void son_created(GnWidget *);

    // Redefine virtual functions
    void before_create(GnWidget *);
    void after_create();
    void register_scrolled_child(GnWidget *);

    GnScrollBar *horizontal_scrollbar;
    GnScrollBar *vertical_scrollbar;
    GnWidget    *clip_window;
    GnWidget    *work_area;
};

class GnVariableScrolledWindow : public GnScrolledWindow {
    META_DEF_1(GnVariableScrolledWindow,GnScrolledWindow);
  public:
    GnVariableScrolledWindow() {}
  protected:
    virtual Widget create_widget(GnWidget *, char *);
    
    // Redefine virtual functions
	
    void before_create(GnWidget *);
    void after_create();
    Boolean show_point( int x, int y );
    Boolean point_visible ( int x, int y );
    void scroll_to ( int x_offset, int y_offset );
};

class GnStaticScrolledWindow : public GnVariableScrolledWindow {
    META_DEF_1(GnStaticScrolledWindow,GnVariableScrolledWindow);
  public:
    GnStaticScrolledWindow() {}
  protected:
    virtual Widget create_widget(GnWidget *, char *);
    
    // Redefine virtual functions
	
    void before_create(GnWidget *);
    void after_create();
};
   
#endif Gina_ScrolledW_H




