// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnShell.h   Version 1.18
//   LastSCCS    : 1/14/92  15:16:13
//   LastEdit    : "Mon Jan 13 09:29:51 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven


#ifndef Gina_Shell_H
#define Gina_Shell_H

class GnShell : public GnComposite {
    META_DEF_1(GnShell,GnComposite);
  public:
    GnShell();
    
    // Methods
    virtual void Popup(XtGrabKind p_grab_kind = XtGrabNone);
    virtual void Popdown();
    
    virtual Boolean preferred_managed()
	{ return False; }

    // Callbacks
    CALLBACK_DEF(popdownCallback);
    CALLBACK_DEF(popupCallback);

    // Resources
    DEF_SET_GET_I(allowShellResize, Boolean);
    DEF_SET_GET_I(geometry, char *);
    DEF_SET_GET_I(overrideRedirect, Boolean);
    DEF_SET_GET_I(saveUnder, Boolean);

  protected:
    // Only necessary to generate a correct virtual table
    virtual Widget create_widget(GnWidget *, char *);
};

class GnWMShell : public GnShell {
     META_DEF_1(GnWMShell,GnShell);
  public:
    GnWMShell();
    
    // Resources
    DEF_SET_GET_I(baseHeight, int);
    DEF_SET_GET_I(baseWidth, int);
    DEF_SET_GET_I(heightInc, int);
    DEF_PIXMAP(iconMask);
    DEF_PIXMAP(iconPixmap);
    DEF_SET_GET_I(iconX, int);
    DEF_SET_GET_I(iconY, int);
    DEF_SET_GET_I(initialState, int);
    DEF_SET_GET_I(input, Boolean);
    DEF_SET_GET_I(maxAspectX, int);
    DEF_SET_GET_I(maxAspectY, int);
    DEF_SET_GET_I(maxHeight, int);
    DEF_SET_GET_I(maxWidth, int);
    DEF_SET_GET_I(minAspectX, int);
    DEF_SET_GET_I(minAspectY, int);
    DEF_SET_GET_I(minHeight, int);
    DEF_SET_GET_I(minWidth, int);
    DEF_SET_GET_I(title, char *);
    DEF_SET_GET_I(transient, Boolean);
    DEF_SET_GET_I(waitForWm, Boolean);
    DEF_SET_GET_I(widthInc, int);
    DEF_SET_GET_I(windowGroup, XID);
    DEF_SET_GET_I(wmTimeout, int);
  protected:  // From base class
    virtual Widget create_widget(GnWidget *, char *);
};

class GnVendorShell : public GnWMShell {
     META_DEF_1(GnVendorShell,GnWMShell);
  public:
    GnVendorShell();

     // Callbacks
    virtual void add_protocol_callback(GnCallback *, Atom, Atom);
    virtual void add_wm_closed_callback(GnCallback *);
    
    // Resources
    DEF_SET_GET_I(deleteResponse, unsigned char);
    DEF_SET_GET_I(keyboardFocusPolicy, unsigned char);
    DEF_SET_GET_I(mwmDecorations, int);
    DEF_SET_GET_I(mwmFunctions, int);
    DEF_SET_GET_I(mwmInputMode, int);
    DEF_SET_GET_I(mwmMenu, char *);
    DEF_SET_GET_I(shellUnitType, unsigned char);
  protected:
    virtual Widget create_widget(GnWidget *, char *);
};

class GnTransientShell : public GnVendorShell {
     META_DEF_1(GnTransientShell,GnVendorShell);
  public:
    GnTransientShell();

  protected:
    // Only necessary to generate a correct virtual table
    virtual Widget create_widget(GnWidget *, char *);
};
    
class GnOverrideShell : public GnShell {
     META_DEF_1(GnOverrideShell,GnShell);
  public:
    GnOverrideShell();

  protected:
    // Only necessary to generate a correct virtual table
    virtual Widget create_widget(GnWidget *, char *);
};

#endif Gina_Shell_H
