// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnViewEdge.h   Version 1.1
//   LastSCCS    : 2/10/92  14:40:03
//   LastEdit    : "Tue Feb 11 12:28:01 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gnviewedge_h
#define Gnviewedge_h

class GnViewNode;
class GnGraphView;
class GnViewEdge : public GnViewObject {
    META_DEF_1(GnViewEdge,GnViewObject);
  private:
    GnGraphView *m_view;
    GnViewNode *m_source, *m_destination;
    Boolean m_hidden;
    int m_x_begin, m_y_begin, m_x_end, m_y_end; 
  public:
    GnViewEdge(GnGraphView *view, GnViewNode *source,GnViewNode *destination);
    ~GnViewEdge();
    GnViewNode *GetDestination(){ return(m_destination); }
    GnViewNode *GetSource(){ return(m_source); }
    void SetBeginCoordinates(int x, int y);
    void SetEndCoordinates(int x, int y);
    void Visualize();
    void Hide();

    //everything from GnViewObject, that has to be specialized

    void draw(int count, int x, int y, Dimension width, Dimension height);
  private:
    void AdjustEnclosingRectangle();
};

DefGenericListWithIterator(GnViewEdgeList,GnViewEdge,GnViewEdgeListIterator);

#endif
