// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnViewNode.h   Version 1.1
//   LastSCCS    : 2/10/92  14:40:05
//   LastEdit    : "Tue Feb 25 15:05:59 1992"
//   Description : 
//   Author      : Andreas Genau
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gnviewnode_h
#define Gnviewnode_h

class GnGraphView;
class GnViewNode : public GnSelectionItem, public GnDirectManipulationObject {
    META_DEF_2(GnViewNode,GnSelectionItem,GnDirectManipulationObject);
  private:
    GnGraphView *m_view;
    GnViewEdgeList m_edges_to, m_edges_from;
    Boolean m_hidden;
    Dimension m_x_string_distance_to_frame, m_y_string_distance_to_frame;
    unsigned int m_visited;
    XmString m_label;
  public:   
    //GraphNodeClass m_node_type; (e.g. Condition, Event)
    
    GnViewNode(GnGraphView *view, GnPresentable *node, unsigned int length);
    void ClearReferences(); //delete the related objects
    void Visualize();
    void Hide();
    Boolean Hidden(){ return(m_hidden); }
    Boolean NoEdgeOfMine(GnViewEdge *edge);
    unsigned int Visited(){ return(m_visited); }
    void BeVisited(){ m_visited++; }
    void BeLessVisited(){ m_visited--; }
    void BeNotVisited(){ m_visited = 0; }
    void CallSelectionCallback();
    void AddEdgeTo(GnViewEdge *edge);
    void AddEdgeFrom(GnViewEdge *edge);
    void RemoveEdgeTo(GnViewEdge *edge);
    void RemoveEdgeFrom(GnViewEdge *edge);
//    void DrawEdgesTo();
//    void DrawEdgesFrom();
    GnPresentable *GetValue(){ return(value); }
    GnViewEdgeList *GetEdgesFrom(){ return(&m_edges_from); }
    GnViewEdgeList *GetEdgesTo(){ return(&m_edges_to); }
    void WhereEdgeMayBegin(GnViewNode *destination, int *x, int *y);
    void WhereEdgeMayEnd(GnViewNode *source, int*x, int *y);
    void WhereEdgeMayBegin(int angle, int *x, int *y);
    void WhereEdgeMayEnd(int angle, int*x, int *y);

    //everything from GnDirectManipulationObject that has to be specialised

    virtual void became_selected();
    virtual void became_unselected();
    void draw(int count, int x, int y, Dimension width, Dimension height);

};

DefGenericListWithIterator(GnViewNodeList,GnViewNode,GnViewNodeListIterator);

#endif





