// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnWidgetItem.h   Version 1.7
//   LastSCCS    : 7/29/91  18:05:06
//   LastEdit    : "Thu Apr  4 09:45:14 1991"
//   Description : 
//   Author      : Andreas Baecker
//   Copyright   : GMD Schloss Birlinghoven

#ifndef GnWidgetitem_h
#define GnWidgetitem_h


class GnItemContext;
class GnCallback;

class GnWidgetItem : public GnObject {
     META_DEF_1(GnWidgetItem,GnObject);
  public:
    // Constructors
    GnWidgetItem(XmString name, GnObject *value,
		Boolean selected = False, Boolean sensitive = True);
    GnWidgetItem(XmString name,
		Boolean selected = False, Boolean sensitive = True);
    
    // Accessors
    XmString Name()
	{ return(name); };
    GnObject *Value()
	{ return(value); };
    Boolean Selected()
	{ return(selected); };
    Boolean Sensitive()
	{ return(sensitive); };

    // Modifiers
    void Name(XmString, Boolean notify = True);
    void Value(GnObject *new_value)
	{ value = new_value; };
    void Selected(Boolean, Boolean notify = True);
    void Sensitive(Boolean, Boolean notify = True);

    // Callback
    void add_itemCallback(GnCallback *);
    GnCallback *remove_itemCallback(Boolean free_it = True);

  private:
    friend class GnSelection;
    friend class GnSingleSelection;
    friend class GmultipleSelection;
    friend class GnRadioButtonGroup;
    friend class GnToggleButtonGroup;
    friend class GnOptionGroup;

    void SelectedFromWidget(Boolean);

    void Context(GnItemContext *, Boolean = False);
    GnItemContext *Context()
	{ return context; };   
    
    XmString      name;
    GnObject      *value;
    Boolean       selected;
    Boolean       sensitive;
    GnItemContext *context;
};

DefGenericListWithIterator(GnWidgetItemList,GnWidgetItem,GnWidgetItemListIterator);

#endif
