// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnWrappers.h   Version 1.7
//   LastSCCS    : 1/14/92  15:16:41
//   LastEdit    : "Thu Dec 19 12:38:30 1991"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Wrappers_h
#define Wrappers_h

class GnInteger : public GnObject {
    META_DEF_1(GnInteger,GnObject);
  public:
    GnInteger()
	{ i = 0; }
    GnInteger(int ii)
	{ i = ii; }
    int Value()
	{ return i; }
    void Value(int ii)
	{ i = ii; }
  private:
    int i;
};

class GnFloat : public GnObject {
     META_DEF_1(GnFloat,GnObject);
  public:
    GnFloat()
	{ f = 0.0; }
    GnFloat(float ff)
	{f = ff; }
    float Value()
	{ return f; }
    void Value(float ff)
	{ f = ff; }
  private:
    float f;
};

class GnStringItem : public GnBitmapFilePresentable {
    META_DEF_1(GnStringItem,GnBitmapFilePresentable);
  public:
    GnStringItem(char *s) : GnBitmapFilePresentable(s) {}
    char *Name()
	{ return BitmapFileName(); }
  public:
    virtual char *PrintOn(char *s, unsigned int length);
};

class GnIntegerItem : public GnInteger, public GnStringItem {
    META_DEF_2(GnIntegerItem,GnInteger,GnStringItem);
  public:
    GnIntegerItem() : GnInteger(0), GnStringItem("0") {}
    GnIntegerItem( char *n, int ii) : GnInteger(ii), GnStringItem(n) {}
};

class GnFloatItem : public GnFloat, public GnStringItem {
    META_DEF_2(GnFloatItem,GnFloat,GnStringItem);
  public:
    GnFloatItem() : GnFloat(0.0), GnStringItem("0.0") {}
    GnFloatItem(char *n, float ff) : GnFloat(ff), GnStringItem(n) {}
};

#endif









