// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnCommand.C   Version 1.21
//   LastSCCS    : 2/26/92  16:36:12
//   LastEdit    : "Mon Feb 24 16:28:29 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

META_IMPL_1(GnCommand,GnObject,);
ImplGenericListWithIterator(GnCommandList,GnCommandListIterator);

GnCommand ::
GnCommand ( GnDocument *doc, GnView *vi, Boolean /* create_cp */ )
{
    Require( doc != 0 );

    document      = doc;
    view          = vi ? vi : doc->get_main_view();
    view_x_offset = 0;
    view_y_offset = 0;

//    if ( create_cp )
//	checkpoint = 0;
//	doc->create_checkpoint( checkpoint );
//    else
//	checkpoint = 0;
}

void GnCommand::
submit()
{
    submit_to_framework();
}

void GnCommand ::
submit_to_framework()
{
    REQUIRE( document != 0, "Document not NULL");
    
    if ( executable() ) {
	if ( clock_cursor() ) {
	    //with_clock_cursor( doit() );
	    doit();
	}
	else {
	    doit();
	}
	if ( causes_change() )
	    document->set_modified( TRUE );
	if ( undoable() )
	    document->register_command( this );
	if ( ! undoable() && causes_change() )
	    document->irreversible_change();
    }
}

void GnCommand ::
doit ()
{
}

void GnCommand ::
undoit ()
{
    //if ( checkpoint )
	//document->restore_checkpoint( checkpoint );
}

void GnCommand ::
redoit ()
{
    doit();
}

void GnCommand ::
commit(Boolean)
{
}

Boolean GnCommand::
IsStorable()
{
    return False;
}

Boolean GnCommand::
WriteToStream(ostream &)
{
    return False;
}

Boolean GnCommand::
ReadFromStream(istream &)
{
    return False;
}

void GnCommand ::
scroll_before_undo()
{
    if ( view ) {
	view->scroller()->scroll_to( view_x_offset, view_y_offset );
	XFlush( GnApplication::get()->get_display() );
    }
}

void GnCommand ::
scroll_before_redo()
{
    if ( view )
	view->scroller()->scroll_to( view_x_offset, view_y_offset );
}

void GnCommand ::
execute_undoit()
{
    undoit_before();
    undoit();
}

void GnCommand ::
execute_redoit()
{
    redoit_before();
    redoit();
}

void GnCommand ::
undoit_before()
{
    scroll_before_undo();
}

void GnCommand ::
redoit_before()
{
    scroll_before_redo();
}
