// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnISILayout.C   Version 1.2
//   LastSCCS    : 2/26/92  15:45:08
//   LastEdit    : "Mon Feb 17 09:27:40 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

META_IMPL_1(GnISILayout,GnLayout,);

GnISILayout::
GnISILayout()
: GnLayout()
{
    m_direction = eHorizontal;
}

unsigned int GnISILayout::
ISIWidth(GnViewNode *node, unsigned int begin)
{
    unsigned int used = begin, coordinate;
    if (node->Visited())
	return(begin);
    node->BeVisited();
    LIST_ITERATE(node->GetEdgesTo(),GnViewEdgeListIterator,it)
	used = ISIWidth(it.Item()->GetDestination(), used);
    if (m_direction == eHorizontal){     
	used = MAX(begin + m_node_height + m_vertical_distance, used);
	coordinate = (used + begin - m_node_height - m_vertical_distance)/2;
	node->move(node->get_x_pos(), coordinate, False);
    }
    else {
	used = MAX(begin + m_node_width + m_horizontal_distance, used);
	coordinate = (used + begin - m_node_width - m_horizontal_distance)/2;
	node->move(coordinate, node->get_y_pos(), False);
    }
    return(used);
}


unsigned int GnISILayout::
ISIDepth(GnViewNode *node)
{
    unsigned int depth = 0;
    if (node->Visited()){
	if (m_direction == eVertical)
	    return(node->get_y_pos() + m_node_height + m_vertical_distance);
	else
	    return(node->get_x_pos() + m_node_width + m_horizontal_distance);
    }
    node->BeVisited();
    LIST_ITERATE(node->GetEdgesFrom(),GnViewEdgeListIterator,it)
	depth = MAX(depth,ISIDepth(it.Item()->GetSource()));
    if (m_direction == eVertical){
	node->move(node->get_x_pos(), depth, False);
	return(depth + m_node_height + m_vertical_distance);
    }
    else {
	node->move(depth, node->get_y_pos(), False);
	return(depth + m_node_width + m_horizontal_distance);
    }
}

void GnISILayout::
DoDepthNodeLayout()
{
    GnViewNode *item;
    unsigned int used_space = 0;
    LIST_ITERATE(m_nodes,GnSelectionItemListIterator,it){
	item = GnViewNode::TypeSafeDownCast(it.Item());
	used_space = MAX(used_space, ISIDepth(item));
    }
}

void GnISILayout::
DoWidthNodeLayout()
{
    GnViewNode *item;
    unsigned int used_space = 0;
    LIST_ITERATE(m_nodes,GnSelectionItemListIterator,it){
	item = GnViewNode::TypeSafeDownCast(it.Item());
	if (item->GetEdgesFrom()->Empty())
	    used_space = ISIWidth(item, used_space);
    }
}

void GnISILayout::
DoNodeLayout()
{
    GnViewNode *item;
    unsigned int used_space = 0;
    LIST_ITERATE(m_nodes,GnSelectionItemListIterator,it){
	item = GnViewNode::TypeSafeDownCast(it.Item());
	m_node_height = MAX(m_node_height, item->get_height());
	m_node_width = MAX(m_node_width, item->get_width());
	item->BeNotVisited();
    }
    DoDepthNodeLayout();
    LIST_ITERATE_WITH(it)
	GnViewNode::TypeSafeDownCast(it.Item())->BeNotVisited();
    DoWidthNodeLayout();
}

void GnISILayout::
DoEdgeLayout()
{
    int x, y;
    LIST_ITERATE(m_edges,GnViewEdgeListIterator,it)
	if (m_direction == eVertical){
	    it.Item()->GetSource()->WhereEdgeMayBegin(270, &x, &y);
	    it.Item()->SetBeginCoordinates(x, y);
	    it.Item()->GetDestination()->WhereEdgeMayEnd(90, &x, &y);
	    it.Item()->SetEndCoordinates(x, y);
	}
	else{
	    it.Item()->GetSource()->WhereEdgeMayBegin(0, &x, &y);
	    it.Item()->SetBeginCoordinates(x, y);
	    it.Item()->GetDestination()->WhereEdgeMayEnd(180, &x, &y);
	    it.Item()->SetEndCoordinates(x, y);
	}
}











