// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnMainMenu.C   Version 1.15
//   LastSCCS    : 1/23/92  12:33:45
//   LastEdit    : "Mon Jan 20 17:02:10 1992"
//   Description : 
//   Author      : Robert Babatz and Andreas Baecker
//   Copyright   : GMD Schloss Birlinghoven

META_IMPL_1(GnMainMenu,GnMenuBar,);

GnMenuEntry *GnMainMenu ::
add_menu_command(char *topic_name, char *topic_label,
		 char *item_name, char *item_label,
		 GnCallback *callback, Boolean sens)
{
    GnPushButtonEntry *menu_entry;
    GnMenuTopic       *topic;

    topic = find_topic(topic_name);
    if( topic == 0 )
	topic = add_topic( topic_name, topic_label );
    
    menu_entry = new GnPushButtonEntry(item_name, item_label, callback, sens);
    topic->add(menu_entry );
    return menu_entry;
}

GnMenuEntry *GnMainMenu::
add_menu_command(char *topic_name, char *item_name,
		 GnCallback *callback, Boolean sens)
{
    return add_menu_command(topic_name, topic_name, item_name, item_name,
			    callback, sens);
}

GnMenuTopic * GnMainMenu ::
find_topic( char * topic_name )
{
    for(GnMenuTopicListIterator it(topics); ! it.Off(); it.Forth() ) {
	if( ! strcmp(it.Item()->get_name(), topic_name) )
	    return it.Item();
    }
    return 0;
}

GnMenuTopic * GnMainMenu ::
add_topic( char * topic_name, char *topic_label )
{
    GnMenuTopic *topic;
    
    topic = new GnMenuTopic(topic_name, topic_label);
    topic->create(this, topic_label);
    topics.Append( topic );
    return topic;
}
