// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnMainWindow.C   Version 1.18
//   LastSCCS    : 1/14/92  15:18:09
//   LastEdit    : "Mon Jan 13 14:04:11 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

extern "C" {
    extern Widget XmCreateMainWindow(Widget, char *, Arg *, int);
    extern void XmMainWindowSetAreas(Widget,Widget,Widget,Widget,Widget,Widget);
}

META_IMPL_1(GnMainWindowMixin,GnObject,);

GnMainWindowMixin::
GnMainWindowMixin(GnMainWindow *p_main_window)
{
    main_window = p_main_window;
}

void GnMainWindowMixin::
setR_mainWindowMarginHeight(Dimension value)
{
    main_window->set_arg(XmNmainWindowMarginHeight, (XtArgVal)value);
}

Dimension GnMainWindowMixin::
getR_mainWindowMarginHeight()
{
    Dimension value;

    main_window->get_arg(XmNmainWindowMarginHeight, (XtArgVal)&value);
    return value;
}

void GnMainWindowMixin::
setR_mainWindowMarginWidth(Dimension value)
{
    main_window->set_arg(XmNmainWindowMarginWidth, (XtArgVal)value);
}

Dimension GnMainWindowMixin::
getR_mainWindowMarginWidth()
{
    Dimension value;

    main_window->get_arg(XmNmainWindowMarginWidth, (XtArgVal)&value);
    return value;
}

void GnMainWindowMixin::
setR_showSeparator(Boolean value)
{
    main_window->set_arg(XmNshowSeparator, (XtArgVal)value);
}

Boolean GnMainWindowMixin::
getR_showSeparator()
{
    Boolean value;

    main_window->get_arg(XmNshowSeparator, (XtArgVal)&value);
    return value;
}

void GnMainWindowMixin ::
SetAreas(GnMenuBar *menu, GnCommandWidget *com,
	 GnScrollBar *hor, GnScrollBar *vert, GnWidget *work )
{
    XmMainWindowSetAreas(main_window->get_widget_id(),
			 menu ? menu->get_widget_id() : NULL,
			 com  ? com->get_widget_id()  : NULL,
			 hor  ? hor->get_widget_id()  : NULL,
			 vert ? vert->get_widget_id() : NULL,
			 work ? work->get_widget_id() : NULL );
}

META_IMPL_2(GnMainWindow,GnVariableScrolledWindow,GnMainWindowMixin,);

GnMainWindow::
GnMainWindow()
: GnVariableScrolledWindow(), GnMainWindowMixin((GnMainWindow *)this)
{
}

Widget GnMainWindow ::
create_widget( GnWidget *par, char * widget_name)
{
    return(XmCreateMainWindow(par->get_widget_id_for_sons(), widget_name,
			      args, args_n));
}

META_IMPL_1(GnVariableMainWindow,GnMainWindow,);

GnVariableMainWindow::
GnVariableMainWindow()
{
}

META_IMPL_2(GnStaticMainWindow,GnStaticScrolledWindow,GnMainWindowMixin,);

GnStaticMainWindow::
GnStaticMainWindow()
: GnStaticScrolledWindow(), GnMainWindowMixin((GnMainWindow *)this)
{
}

Widget GnStaticMainWindow::create_widget(GnWidget *par, char *widget_name)
{
    return(XmCreateMainWindow(par->get_widget_id_for_sons(), widget_name,
			      args, args_n));
}
