// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnWidgetItem.C   Version 1.6
//   LastSCCS    : 10/24/91  17:35:10
//   LastEdit    : "Fri Sep 13 12:56:53 1991"
//   Description : 
//   Author      : Andreas Baecker
//   Copyright   : GMD Schloss Birlinghoven


META_IMPL_1(GnWidgetItem,GnObject,);

GnWidgetItem::
GnWidgetItem(XmString name, GnObject *value,
	    Boolean selected, Boolean sensitive)
{
    this->name = name;
    this->value = value;
    this->selected = selected;
    this->sensitive = sensitive;
    this->context = 0;
}

GnWidgetItem::
GnWidgetItem(XmString name, Boolean selected, Boolean sensitive)
{
    this->name = name;
    this->value = this;
    this->selected = selected;
    this->sensitive = sensitive;
    this->context = 0;
}

void GnWidgetItem::
Name(XmString new_name, Boolean notify)
{
    if(notify && context && context->name_changeable())
	context->Name(new_name);
    else
	name = new_name;

}

void GnWidgetItem::
Selected(Boolean new_state, Boolean notify)
{
    if(context && context->selectable())
	context->Selection()->Selected(this, new_state, notify);
}

void GnWidgetItem::
SelectedFromWidget(Boolean new_state)
{
    selected = new_state;
}

void GnWidgetItem::
Sensitive(Boolean new_state, Boolean notify)
{
    sensitive = new_state;
    if(notify && context && context->sensitivity())
	context->Sensitive(new_state);
}

void GnWidgetItem::
Context(GnItemContext *new_context, Boolean propagate)
{
    context = new_context;
    if( propagate ) {
	if(context->name_changeable())
	    context->Name(name);
	if(context->sensitivity())
	    context->Sensitive(sensitive);
	if(context->sensitivity())
	    context->Selected(selected);
    }
}

void GnWidgetItem::
add_itemCallback(GnCallback *callback)
{
    if(context && context->with_callback())
	context->add_itemCallback(callback);
}

GnCallback *GnWidgetItem::
remove_itemCallback(Boolean free_it)
{
    GnCallback *cb;

    if(context && context->with_callback()) {
	cb = context->remove_itemCallback();
	if(free_it) {
	    delete cb;
	    return 0;
	}
	else { 
	    return cb;
	}
    } else {
	return 0;
    }
}














